#include <unistd.h>
#import "HumaneText.h"

@implementation HumaneText

- (NSString *)filter:(NSString *)s
{
  NSTask *t = [[NSTask alloc] init];
  NSPipe *pin = [NSPipe pipe];
  NSPipe *pout = [NSPipe pipe];
  NSFileHandle *stdin_fh = [pin fileHandleForWriting];
  NSFileHandle *stdout_fh = [pout fileHandleForReading];
  NSTimeInterval to = [[[NSDate date] addTimeInterval:1.0] timeIntervalSinceReferenceDate];
  BOOL expired = NO;
  NSString *ret = nil;

//  [t setLaunchPath:[[NSBundle mainBundle] pathForResource:@"textile" ofType:@"py"]];
  [t setLaunchPath:[[NSBundle mainBundle] pathForResource:@"filter" ofType:nil]];
  [t setStandardInput:pin];
  [t setStandardOutput:pout];
  [t launch];

  [stdin_fh writeData:[s dataUsingEncoding:[NSString defaultCStringEncoding]]];
  [stdin_fh closeFile];

  while (!expired && [t isRunning]) {
    if ([[NSDate date] timeIntervalSinceReferenceDate] > to ) expired = YES;
    usleep(100000);
  }

  if (!expired) {
    if ([t terminationStatus] == 0) {
      NSData *d = [stdout_fh readDataToEndOfFile];
      ret = [NSString stringWithCString:[d bytes] length:[d length]];
    }
  } else {
    [t interrupt];
    if ([t isRunning]) [t terminate];
  }
  
  [t release];
  return ret;
}

- (void)doFilter:(NSPasteboard *)pboard
        userData:(NSString *)userData
           error:(NSString **)error
{
  NSString *pboardString;
  NSString *newString;
  NSArray *types;

  types = [pboard types];
  if (![types containsObject:NSStringPboardType]) {
    *error = NSLocalizedString(@"Error: PBoard contains nothing we recognize.",
                               @"pboard couldn't give string.");
    return;
  }
  pboardString = [pboard stringForType:NSStringPboardType];
  if (!pboardString) {
    *error = NSLocalizedString(@"Error: couldn't get the PBoard string.",
                               @"pboard couldn't give string.");
    return;
  }
  newString = [self filter:pboardString];
  if (!newString) {
    *error = NSLocalizedString(@"Error: couldn't filter text.",
                               @"self couldn't filter input.");
    return;
  }
  types = [NSArray arrayWithObject:NSStringPboardType];
  [pboard declareTypes:types owner:nil];
  [pboard setString:newString forType:NSStringPboardType];
  return;
}

@end